/*
 * Copyright 2006-2007 Queplix Corp.
 *
 * Licensed under the Queplix Public License, Version 1.1.1 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.queplix.com/solutions/commercial-open-source/queplix-public-license/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 *
 */

package com.queplix.core.modules.eql;

import com.queplix.core.jxb.entity.Dataset;
import com.queplix.core.jxb.entity.Entity;

/**
 * <p>EQL Request Dataset object</p>
 *
 * @author Baranov Andrey [ALB]
 * @version $Revision: 1.1.1.1 $ $Date: 2005/09/12 15:30:20 $
 */

public class EQLReqDataset
        implements java.io.Serializable {

    // ------------------------------------------------------- variables

    private EQLReqEntity reqEntity;
    private Dataset ds;
    private Entity dsEntity;

    // ------------------------------------------------------- constructor

    public EQLReqDataset(EQLReqEntity reqEntity, Dataset ds, Entity dsEntity) {
        this.reqEntity = reqEntity;
        this.ds = ds;
        this.dsEntity = dsEntity;
    }

    public EQLReqDataset(Entity entity, Dataset ds, Entity dsEntity) {
        this(new EQLReqEntity(entity), ds, dsEntity);
    }

    // ------------------------------------------------------- public methods

    public EQLReqEntity getReqEntity() {
        return reqEntity;
    }

    public Dataset getDataset() {
        return ds;
    }

    public Entity getDatasetEntity() {
        return dsEntity;
    }

    public int hashCode() {
        return reqEntity.hashCode() | ds.hashCode();
    }

    public boolean equals(Object o) {
        if(o == null) {
            return false;
        }

        if(o == this) {
            return true;
        }

        if(o instanceof EQLReqDataset) {
            EQLReqDataset reqDataset = (EQLReqDataset) o;

            return ds.getName().equals(reqDataset.getDataset().getName()) &&
                    reqEntity.equals(reqDataset.getReqEntity());
        }

        return false;
    }

    public String toString() {
        return "reqEntity=[" + reqEntity + "] dataset=" + ds.getName();
    }
}
